package main

import (
	"database/sql"
	"encoding/json"
	"fmt"
	"net/http"
	"strconv"
	"time"

	"os"

	"log"

	"github.com/dgrijalva/jwt-go"
	_ "github.com/go-sql-driver/mysql"
	_ "github.com/golang-jwt/jwt/v5"
	"github.com/joho/godotenv"
	echojwt "github.com/labstack/echo-jwt/v4"
	"github.com/labstack/echo/v4"
	"github.com/labstack/echo/v4/middleware"
	echoSwagger "github.com/swaggo/echo-swagger"
	xendit "github.com/xendit/xendit-go/v5"
	invoice "github.com/xendit/xendit-go/v5/invoice"
	"golang.org/x/crypto/bcrypt"

	_ "iohtestsetiady/docs" // docs is generated by Swag CLI, you have to import it.
)

// @title IOH Test Setiady - Invoice API
// @version 1.0
// @description IOH Test Simple Invoice API.
// @termsOfService http://swagger.io/terms/
// @contact.name Setiady Mulya
// @contact.url https://www.linkedin.com/in/setiady-mulya
// @contact.email setiady.mulya@gmail.com
// @license.name Apache 2.0
// @license.url http://www.apache.org/licenses/LICENSE-2.0.html
// @host localhost:8002
// @BasePath /

// @securityDefinitions.apikey ApiKeyAuth
// @in header
// @name Authorization
type (
	Invoice struct {
		ID              int     `json:"id,omitempty"`
		User            string  `json:"user"`
		InvoiceNumber   string  `json:"invoice_number" binding:"required"`
		DueDate         string  `json:"due_date" binding:"required"`
		ItemName        string  `json:"item_name" binding:"required"`
		Quantity        int     `json:"quantity" binding:"required"`
		Amount          float64 `json:"amount" binding:"required"`
		XenditInvoiceID string  `json:"xendit_invoice_id,omitempty"`
	}

	User struct {
		ID        int    `json:"id"`
		Username  string `json:"username"`
		Password  string `json:"password"`
		Email     string `json:"email"`
		FirstName string `json:"firstname"`
		LastName  string `json:"lastname"`
	}

	JwtRes struct {
		Raw    string `json:"Raw"`
		Method struct {
			Name string `json:"Name"`
			Hash int    `json:"Hash"`
		} `json:"Method"`
		Header struct {
			Alg string `json:"alg"`
			Typ string `json:"typ"`
		} `json:"Header"`
		Claims struct {
			Email     string `json:"email"`
			Exp       int    `json:"exp"`
			Firstname string `json:"firstname"`
			Lastname  string `json:"lastname"`
			Username  string `json:"username"`
		} `json:"Claims"`
		Signature string `json:"Signature"`
		Valid     bool   `json:"Valid"`
	}
)

var (
	db           *sql.DB
	jwtSecretKey string
)

func isEmptyJwtRes(jwtData JwtRes) (result JwtRes, ok bool) {
	// Check if all fields have zero values
	ok = jwtData.Raw != "" && jwtData.Claims.Exp != 0 && jwtData.Claims.Email != ""
	return jwtData, ok
}

func main() {
	var err error
	// Open a connection to the database
	err = godotenv.Load()
	if err != nil {
		log.Fatal("Error loading .env file")
		panic(err)
	}

	// Retrieve environment variables
	dbUname := os.Getenv("DB_USERNAME")
	dbPwd := os.Getenv("DB_PASSWORD")
	host := os.Getenv("DB_HOST")
	dbName := os.Getenv("DB_NAME")
	port := os.Getenv("DB_PORT")
	xenditSecretKey := os.Getenv("XENDIT_SECRET_KEY")
	jwtSecretKey = os.Getenv("JWT_SECRET_KEY")

	db, err = sql.Open("mysql", fmt.Sprintf("%s:%s@tcp(%s:%s)/%s", dbUname, dbPwd, host, port, dbName))
	if err != nil {
		panic(err)
	}

	defer db.Close()

	// Test the connection to the database
	err = db.Ping()
	if err != nil {
		panic(err)
	}

	// Initialize Echo
	e := echo.New()

	// Middleware
	e.Use(middleware.Logger())
	e.Use(middleware.Recover())

	e.GET("/docs/*", echoSwagger.WrapHandler)

	// @Tags Invoice
	// @Summary Login user
	// @Description Authenticate user with username and password
	// @Accept  json
	// @Produce  json
	// @Param   credentials  body   User  true   "Credentials"
	// @Success 200 {object} map[string]interface{}
	// @Failure 400 {object} map[string]string
	// @Failure 401 {object} map[string]string
	// @Failure 500 {object} map[string]string
	// @Router /login [post]
	e.POST("/login", func(c echo.Context) error {
		var credentials struct {
			Username string `json:"username"`
			Password string `json:"password"`
		}

		if err := c.Bind(&credentials); err != nil {
			return c.JSON(http.StatusBadRequest, map[string]string{"error": "Invalid request payload"})
		}

		rows, err := db.Query("SELECT id, username, password, email, firstname, lastname FROM users WHERE username = ?", credentials.Username)

		if err != nil {
			log.Fatal("Error select users : ", err.Error())
			panic(err.Error())
		}
		defer rows.Close()

		var user User
		for rows.Next() {
			err = rows.Scan(&user.ID, &user.Username, &user.Password, &user.Email, &user.FirstName, &user.LastName)
			if err != nil {
				log.Fatal(err)
			}
		}

		if err != nil {
			log.Fatal(err)
			panic(err)
		}

		// Compare the stored hashed password with the provided password
		if err := bcrypt.CompareHashAndPassword([]byte(user.Password), []byte(credentials.Password)); err != nil {
			return c.JSON(http.StatusUnauthorized, map[string]string{"error": "Invalid username or password"})
		}

		// Create JWT token
		token := jwt.NewWithClaims(jwt.SigningMethodHS256, jwt.MapClaims{
			"username":  user.Username,
			"email":     user.Email,
			"firstname": user.FirstName,
			"lastname":  user.LastName,
			"exp":       time.Now().Add(time.Hour * 72).Unix(),
		})

		tokenString, err := token.SignedString([]byte(jwtSecretKey))
		if err != nil {
			return c.JSON(http.StatusInternalServerError, map[string]string{"error": "Failed to generate token"})
		}

		return c.JSON(http.StatusOK, map[string]interface{}{
			"token":     tokenString,
			"username":  user.Username,
			"email":     user.Email,
			"firstname": user.FirstName,
			"lastname":  user.LastName,
		})
	})

	// @Tags Invoice
	// @Summary Register user
	// @Description Register a new user
	// @Accept  json
	// @Produce  json
	// @Param   user  body   User  true   "User"
	// @Success 201 {object} map[string]string
	// @Failure 400 {object} map[string]string
	// @Failure 500 {object} map[string]string
	// @Router /register [post]
	e.POST("/register", func(c echo.Context) error {
		var user User
		if err := c.Bind(&user); err != nil {
			return c.JSON(http.StatusBadRequest, map[string]string{"error": "Invalid request payload"})
		}

		// Hash the user's password
		hashedPassword, err := bcrypt.GenerateFromPassword([]byte(user.Password), bcrypt.DefaultCost)
		if err != nil {
			return c.JSON(http.StatusInternalServerError, map[string]string{"error": "Failed to hash password"})
		}
		user.Password = string(hashedPassword)

		// Insert the user into the database
		query := "INSERT INTO users (username, password, email, firstname, lastname) VALUES (?, ?, ?, ?, ?)"
		_, err = db.Exec(query, user.Username, user.Password, user.Email, user.FirstName, user.LastName)
		if err != nil {
			return c.JSON(http.StatusInternalServerError, map[string]string{"error": "Failed to register user"})
		}

		return c.JSON(http.StatusCreated, map[string]string{"message": "User registered successfully"})
	})

	// Restricted group
	r := e.Group("/invoices")
	r.Use(echojwt.WithConfig(echojwt.Config{
		SigningKey:    []byte(jwtSecretKey),
		SigningMethod: "HS256",
	}))

	// @Tags Invoice
	// @Summary Create invoice
	// @Description Create a new invoice
	// @Accept  json
	// @Produce  json
	// @Param   invoice  body   Invoice  true   "Invoice"
	// @Success 201 {object} Invoice
	// @Failure 400 {object} map[string]string
	// @Failure 500 {object} map[string]string
	// @Security ApiKeyAuth
	// @Router /invoices [post]
	r.POST("", func(c echo.Context) error {
		u := c.Get("user")

		// Marshal the claims into JSON format
		jsonBytes, err := json.Marshal(u)
		if err != nil {
			return c.JSON(http.StatusInternalServerError, map[string]string{"error": "Error marshalling claims to JSON"})
		}

		var resJwt JwtRes
		err = json.Unmarshal(jsonBytes, &resJwt)
		if err != nil {
			return c.JSON(http.StatusInternalServerError, map[string]string{"error": "Error unmarshalling JSON:" + err.Error()})
		}

		claims, ok := isEmptyJwtRes(resJwt)
		if !ok {
			return c.JSON(http.StatusInternalServerError, map[string]string{"error": "failed to cast claims as jwt.MapClaims"})
		}

		username := claims.Claims.Username
		email := claims.Claims.Email

		inv := new(Invoice)
		inv.User = claims.Claims.Username

		if err := c.Bind(&inv); err != nil {
			return c.JSON(http.StatusBadRequest, map[string]string{
				"error": err.Error(),
			})
		}
		// Create the invoice in your database
		query := "INSERT INTO invoices (user, invoice_number, due_date, item_name, quantity, amount) VALUES (?, ?, ?, ?, ?, ?)"
		res, err := db.Exec(query, username, inv.InvoiceNumber, inv.DueDate, inv.ItemName, inv.Quantity, inv.Amount)
		if err != nil {
			return c.JSON(http.StatusInternalServerError, map[string]string{"error": err.Error()})
		}

		id, err := res.LastInsertId()
		if err != nil {
			return c.JSON(http.StatusInternalServerError, map[string]string{"error": "Failed to retrieve last insert id"})
		}

		createInvoiceRequest := *invoice.NewCreateInvoiceRequest(fmt.Sprintf("Invoice %s", inv.InvoiceNumber), float64(123)) // [REQUIRED] | CreateInvoiceRequest
		forUserId := email

		xenditClient := xendit.NewClient(xenditSecretKey)

		resp, r, err := xenditClient.InvoiceApi.CreateInvoice(c.Request().Context()).
			CreateInvoiceRequest(createInvoiceRequest).
			ForUserId(forUserId).
			Execute()

		if err != nil {
			fmt.Fprintf(os.Stderr, "Error when calling `InvoiceApi.CreateInvoice``: %v\n", err.Error())

			b, _ := json.Marshal(err.Error())
			fmt.Fprintf(os.Stderr, "Full Error Struct: %v\n", string(b))

			fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
		}
		// response from `CreateInvoice`: Invoice
		fmt.Fprintf(os.Stdout, "Response from `InvoiceApi.CreateInvoice`: %v\n", resp)

		// // Update your invoice record with Xendit invoice ID
		// _, err = db.Exec("UPDATE invoices SET xendit_invoice_id = ? WHERE id = ?", xenditInvoice.ID, id)
		// if err != nil {
		// 	return c.JSON(http.StatusInternalServerError, map[string]string{"error": "Failed to update invoice with Xendit invoice ID"})
		// }

		inv.ID = int(id)
		// inv.XenditInvoiceID = xenditInvoice.ID
		return c.JSON(http.StatusCreated, inv)
	})

	// @Tags Invoice
	// @Summary Update invoice
	// @Description Update an existing invoice
	// @Accept  json
	// @Produce  json
	// @Param   id  path   int  true  "Invoice ID"
	// @Param   invoice  body   Invoice  true   "Invoice"
	// @Success 200 {object} Invoice
	// @Failure 400 {object} map[string]string
	// @Failure 500 {object} map[string]string
	// @Security ApiKeyAuth
	// @Router /invoices/{id} [put]
	r.PUT("/:id", func(c echo.Context) error {
		u := c.Get("user")

		// Marshal the claims into JSON format
		jsonBytes, err := json.Marshal(u)
		if err != nil {
			return c.JSON(http.StatusInternalServerError, map[string]string{"error": "Error marshalling claims to JSON"})
		}

		var resJwt JwtRes
		err = json.Unmarshal(jsonBytes, &resJwt)
		if err != nil {
			return c.JSON(http.StatusInternalServerError, map[string]string{"error": "Error unmarshalling JSON:" + err.Error()})
		}

		claims, ok := isEmptyJwtRes(resJwt)
		if !ok {
			return c.JSON(http.StatusInternalServerError, map[string]string{"error": "failed to cast claims as jwt.MapClaims"})
		}

		username := claims.Claims.Username
		id := c.Param("id")
		invoice := new(Invoice)
		if err := c.Bind(invoice); err != nil {
			return c.JSON(http.StatusBadRequest, map[string]string{"error": "Invalid request payload"})
		}

		query := "UPDATE invoices SET user = ?, due_date = ?, item_name = ?, quantity = ?, amount = ? WHERE id = ?"
		_, err = db.Exec(query, username, invoice.DueDate, invoice.ItemName, invoice.Quantity, invoice.Amount, id)
		if err != nil {
			return c.JSON(http.StatusInternalServerError, map[string]string{"error": err.Error()})
		}

		query = "SELECT id, user, invoice_number, due_date, item_name, quantity, amount, xendit_invoice_id FROM invoices WHERE id = ?"
		err = db.QueryRow(query, id).Scan(&invoice.ID, &invoice.User, &invoice.InvoiceNumber, &invoice.DueDate, &invoice.ItemName, &invoice.Quantity, &invoice.Amount, &invoice.XenditInvoiceID)
		if err == sql.ErrNoRows {
			return c.JSON(http.StatusNotFound, map[string]string{"error": "Invoice not found"})
		} else if err != nil {
			return c.JSON(http.StatusInternalServerError, map[string]string{"error": "Failed to fetch invoice"})
		}

		return c.JSON(http.StatusOK, invoice)
	})

	// @Tags Invoice
	// @Summary Get all invoices
	// @Description Retrieve all invoices
	// @Accept  json
	// @Produce  json
	// @Param   page  query  int  false  "Page number"
	// @Param   pageSize  query  int  false  "Page size"
	// @Success 200 {array} Invoice
	// @Failure 500 {object} map[string]string
	// @Security ApiKeyAuth
	// @Router /invoices [get]
	r.GET("", func(c echo.Context) error {
		pageStr := c.QueryParam("page")
		pageSizeStr := c.QueryParam("pageSize")

		page, err := strconv.Atoi(pageStr)
		if err != nil || page < 1 {
			page = 1
		}
		pageSize, err := strconv.Atoi(pageSizeStr)
		if err != nil || pageSize < 1 {
			pageSize = 10
		}

		offset := (page - 1) * pageSize

		query := "SELECT id, user, invoice_number, due_date, item_name, quantity, amount, xendit_invoice_id FROM invoices LIMIT ? OFFSET ?"
		rows, err := db.Query(query, pageSize, offset)
		if err != nil {
			return c.JSON(http.StatusInternalServerError, map[string]string{"error": "Failed to fetch invoices"})
		}
		defer rows.Close()

		invoices := []Invoice{}
		for rows.Next() {
			var invoice Invoice
			if err := rows.Scan(&invoice.ID, &invoice.User, &invoice.InvoiceNumber, &invoice.DueDate, &invoice.ItemName, &invoice.Quantity, &invoice.Amount, &invoice.XenditInvoiceID); err != nil {
				return c.JSON(http.StatusInternalServerError, map[string]string{"error": err.Error()})
			}
			invoices = append(invoices, invoice)
		}

		return c.JSON(http.StatusOK, invoices)
	})

	// @Tags Invoice
	// @Summary Get invoice by ID
	// @Description Retrieve a single invoice by its ID
	// @Accept  json
	// @Produce  json
	// @Param   id  path   int  true  "Invoice ID"
	// @Success 200 {object} Invoice
	// @Failure 404 {object} map[string]string
	// @Failure 500 {object} map[string]string
	// @Security ApiKeyAuth
	// @Router /invoices/{id} [get]
	r.GET("/:id", func(c echo.Context) error {
		id := c.Param("id")

		var invoice Invoice
		query := "SELECT id, user, invoice_number, due_date, item_name, quantity, amount, xendit_invoice_id FROM invoices WHERE id = ?"
		err := db.QueryRow(query, id).Scan(&invoice.ID, &invoice.User, &invoice.InvoiceNumber, &invoice.DueDate, &invoice.ItemName, &invoice.Quantity, &invoice.Amount, &invoice.XenditInvoiceID)
		if err == sql.ErrNoRows {
			return c.JSON(http.StatusNotFound, map[string]string{"error": "Invoice not found"})
		} else if err != nil {
			return c.JSON(http.StatusInternalServerError, map[string]string{"error": "Failed to fetch invoice"})
		}

		return c.JSON(http.StatusOK, invoice)
	})

	// @Tags Invoice
	// @Summary Delete invoice
	// @Description Delete an invoice by its ID
	// @Accept  json
	// @Produce  json
	// @Param   id  path   int  true  "Invoice ID"
	// @Success 204
	// @Failure 500 {object} map[string]string
	// @Security ApiKeyAuth
	// @Router /invoices/{id} [delete]
	r.DELETE("/:id", func(c echo.Context) error {
		id := c.Param("id")

		query := "DELETE FROM invoices WHERE id = ?"
		_, err := db.Exec(query, id)
		if err != nil {
			return c.JSON(http.StatusInternalServerError, map[string]string{"error": err.Error()})
		}

		return c.JSON(http.StatusOK, map[string]string{"message": "Invoice has been deleted"})
	})

	// Start server
	e.Logger.Fatal(e.Start(":8002"))
}
